<?php

/**
 * registro_concepto actions.
 *
 * @package    cobro_coactivo
 * @subpackage registro_concepto
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class registro_conceptoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_REGISTRO_CONCEPTO',
        'CBR_TITULO_MINERO_V',
        'CBR_ACTUALIZA_TITULO_V',
        'CBR_RESOLUCION_TIT',
        'CBR_CONCEPTO_DEUDA'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REGISTRO_CONCEPTO'
        ),
        'CBR_ACTUALIZA_TITULO_V,LEFT'=>
        array(
            'cod_titulo' => 'CBR_REGISTRO_CONCEPTO'
        ),
        'CBR_RESOLUCION_TIT' =>
        array(
            'id_resolucion_tit' => 'CBR_REGISTRO_CONCEPTO'
        ),
        'CBR_CONCEPTO_DEUDA' =>
        array(
            'id_concepto_deuda' => 'CBR_REGISTRO_CONCEPTO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_REGISTRO_CONCEPTO' =>
        array(
            'id_registro_concepto' => 'id_registro_concepto',
            'cod_titulo' => 'cod_titulo',
            'id_resolucion_tit' => 'id_resolucion_tit',
            'id_concepto_deuda' => 'id_concepto_deuda',
            'valor' => 'valor',
            'abonos' => 'abonos',
            'saldo' => 'saldo'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral_deb',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral_deb'
        ),
        'CBR_ACTUALIZA_TITULO_V'=>
        array(
            'mineral' => 'mineral',
            'id_mineral' => 'id_mineral',
            'cod_mineral' => 'cod_mineral'
        ),
        'CBR_RESOLUCION_TIT' =>
        array(
            'no_resolucion' => 'no_resolucion',
            'fecha_expedicion' => 'fecha_resolucion'
        ),
        'CBR_CONCEPTO_DEUDA' =>
        array(
            'descripcion' => 'descripcion_concepto'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_REGISTRO_CONCEPTO' =>
        array(
            'id_registro_concepto,a' => array('!=' => array(-1)),
            'id_registro_concepto,b' => array('=' => array('id_registro_concepto')),
            'cod_titulo' => array('=' => array('cod_titulo')),
            'id_concepto_deuda' => array('=' => array('id_concepto_deuda')),
            'id_resolucion_tit' => array('=' => array('id_resolucion_tit')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_registro_concepto'; //identificador de la tabla
    protected $id_names = array('id_registro_concepto'); //llave primaria
    protected $field_names = array('cod_titulo', 'id_resolucion_tit', 'id_concepto_deuda', 'valor', 'abonos', 'saldo'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_REGISTRO_CONCEPTO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_registro_concepto'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //$request['abonos']=0;
            $request['saldo'] = $request['valor'];
        }

        //accion update
        if ($Action == "UPDATE") {

            $request['saldo'] = $request['valor'];
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a validateRemove");


        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_registro_concepto = $request['id_registro_concepto'];

        /*
         *  Generar errores en $errors - 20200224
         */
        //Mira si tiene abonos
        //sentencia sql
        $sql = <<<EOD
SELECT
    *
FROM cbr_abono_concepto
where id_registro_concepto = $id_registro_concepto
EOD;
        //ejecuta el sql
        $records_rend = CN_TABLE::executeSQL($sql);
        if (count($records_rend) > 0) {

            $errors['mensaje'] = "Existen registros de abonos; no puede eliminar el concepto, favor verificar.";
            $errors['servicio'] = "registro_concepto";
            $logger->info("Existen registros de abonos; no puede eliminar el concepto, favor verificar.");
        }

        //Mira si tiene debitos
        //sentencia sql
        $sql = <<<EOD
SELECT
    *
FROM cbr_registro_nd
where id_registro_concepto = $id_registro_concepto 
EOD;
        //ejecuta el sql
        $records_rend = CN_TABLE::executeSQL($sql);
        if (count($records_rend) > 0) {

            $errors['mensaje'] = "Existen registros de ND; no puede eliminar el concepto, favor verificar.";
            $errors['servicio'] = "registro_concepto";
            $logger->info("Existen registros de ND; no puede eliminar el concepto, favor verificar.");
        }

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a validateUpdate");

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_registro_concepto = $request['id_registro_concepto'];
        $valor_upt = $request['valor'];

        /*
         *  Generar errores en $errors
         */
        //sentencia sql
        $sql = <<<EOD
select
cont.id_registro_concepto,
cont.valor as valor,
sum(novdes.valor_abono) as valor_abono

from cbr_registro_concepto cont

left join cbr_abono_concepto novdes
on novdes.id_registro_concepto = cont.id_registro_concepto

where
cont.id_registro_concepto = $id_registro_concepto

group by
cont.id_registro_concepto,
cont.valor 
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);

        //Valida que el nuevo total sea superior al abono - 20200224
        if (count($records) > 0) {

            $valor_abono = $records[0]['valor_abono'];

            if ($valor_upt < $valor_abono) {

                $valor_upt_text = number_format($valor_upt);
                $valor_abono_text = number_format($valor_abono);

                $errors['mensaje'] = "El valor nuevo del concepto($valor_upt_text) no supera el total de abonos($valor_abono_text), verificar.";
                $errors['servicio'] = "registro_concepto";
                $logger->info("El valor nuevo del concepto($valor_upt_text) no supera el total de abonos($valor_abono_text), verificar.");
            }
        }

        return $errors;
    }

}
